//+------------------------------------------------------------------+
//|                                                   Order_Time.mq4 |
//|                                                            IgorM |
//|                                        http://forum.mql4.com/ru/ |
//+------------------------------------------------------------------+
#property copyright "IgorM"
#property link      "http://forum.mql4.com/ru/"

extern string     _P1         = " : 1 BUY ;  2 -SELL";
extern int        order_type  = 1;
extern int        Hour_Time1  = 0;        //   
extern int        Hour_Time2  = 1;        //   
extern string     _P2         =  "   (-0,1,2,3,4,5,6)";
extern int        Day_Week1   = 1;        //   
extern int        Day_Week2   = 1;        //   
extern double     Lot         = 0.01;
extern int        StopLoss    = 300;      //  
extern int        TakeProfit  = 500;      //  
extern int        Slippage    = 50;      //     
extern int        Magic       = 123456;

bool MyOrderOK = false ; 

int init()
  {
   return(0);
  }

int deinit()
  {
   return(0);
  }
  
int MyOrderSend()
{
   int cmd, ticket=-1;
   double SL, TP, PR;
   if (order_type == 1){ cmd = OP_BUY; PR = NormalizeDouble(Ask,Digits); }
   if (order_type == 2){ cmd = OP_SELL; PR = NormalizeDouble(Bid,Digits); }
   
   if (StopLoss==0) SL=0; else SL = NormalizeDouble(PR - StopLoss * Point, Digits);
   if (TakeProfit==0) TP=0; else TP = NormalizeDouble(PR + TakeProfit * Point, Digits);
   
   ticket = OrderSend(Symbol(),cmd, Lot, PR, Slippage, SL, TP, NULL, Magic, 0, Blue);
   if (ticket > 0) {
      if (OrderSelect(ticket, SELECT_BY_TICKET,MODE_TRADES)) Print("Order opened : ", OrderOpenPrice());
      MyOrderOK = true; 
   }
   else Print("  ",GetLastError(),"   ");
   
   return(0);
}

int MyOrderClose()
{
   int cmd;
   if (order_type == 1) cmd = OP_BUY; 
   if (order_type == 2) cmd = OP_SELL;
   for (int i=OrdersTotal()-1;i>=0;i--) {
      OrderSelect(i, cmd, MODE_TRADES);
      if (OrderMagicNumber() == Magic)
                if (OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, Violet)) { OrderPrint();  MyOrderOK = false; }
                        else Print("  ",GetLastError(),"   ");
   }
}

int start()
  { 
//     &&     &&         
      if ((!MyOrderOK) &&(DayOfWeek()== Day_Week1) && (Hour_Time1 ==TimeHour(TimeCurrent()))) MyOrderSend();
      if ((MyOrderOK) &&(DayOfWeek()== Day_Week2) && (Hour_Time2 ==TimeHour(TimeCurrent()))) MyOrderClose();
      Sleep(60000); //   
   return(0); 
  }